import numpy as np

from traits.api import Button

from traitsui.api import View

import geolab as geo


class Test(geo.geolab_component):

    run = Button()

    view = View('run')

    def geolab_started(self):

        def plot():
            obj = self.geolab.current_object
            obj.plot_faces()
            obj.plot_edges()

        self.geolab.add_plot_callback(plot)
        self.geolab.initialize_plot()

    def _run_fired(self):
        obj = self.geolab.current_object
        obj.vertices[:, 1] *= 1.1
        self.geolab.update_plot()


if __name__ == '__main__':

    V1, F1 = geo.mesh_plane()

    gui = geo.geolab_gui()

    gui.open_mesh(V1, faces=F1, name='a')

    V, F = geo.mesh_torus()

    gui.open_mesh(V, faces=F, name='b')

    gui.add_component(Test())

    gui.start()




